/*	
 *	clippce.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Wed Apr 24 09:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Jun  2 04:45:00 JST 2002 Naoyuki Sawa
 *	- pceAppInit()ōpceLCDDrawObjectCXg[A
 *	  pceAppExit()ōpceLCDDrawObjectACXg[悤ɂ܂B
 *	  AAvP[Vł̍ƂsKv͂܂B
 *	* Sun Jun  2 20:07:00 JST 2002 Naoyuki Sawa
 *	- pceLCDDrawObject()clipdobj.cɕB
 *	* Thu May 13 22:00:00 JST 2002 Naoyuki Sawa
 *	- 󂫃̑啔malloc()pq[vƂĊmۂ悤ɕύXB
 *	- s\̂鏉ApceAppInit()app_init()ɕB
 *	- ʃx֐/_~[֐̍쐬JnB
 *	* Fri Jun 21 19:22:00 JST 2002 Naoyuki Sawa
 *	- GSM̃[eBeB֐ǉB
 *	* Fri Jun 22 09:09:00 JST 2002 Naoyuki Sawa
 *	- 荞݃[`stream_isr()Apsr󂵂Ă܂Ă̂CB
 *	  GSMĐ[`ɂĊm̃oO͂Ƃ肠SԂƎvB
 */
#include "clip.h"
#include "clipdobj.c" /* pceLCDDrawObject */

/*****************************************************************************
 *	O[oϐ
 *****************************************************************************/

/* S1C33 Family CRpCpbP[Wł́Aerrno̓AvP[VŒ`Kv܂B
 * [S5U1C33000C_J.pdf p.140]
 */
int errno;

/*****************************************************************************
 *	[Jϐ
 *****************************************************************************/

/* vOIɎs֐ւ̃|C^B
 * atexit()œo^܂B(݂̎ł͈x݂̂łB)
 * NULLȂA܂o^Ă܂B
 */
static void (*exit_func)();

/* * 󂫃̑啔malloc()pq[vƂĊmۂ܂B
 *   AvP[Ṽmۂ́ApceHeapAlloc()ł͂Ȃmalloc()gĂB
 * * pceFilenAPIpceHeapAlloc()gA4`8KBx̃mۂŝŁA
 *   VXepq[v̈ƂāA󂫃cĂKv܂B
 * * BIOS1.18݁ApceFileLoad()(0x2000-32)oCg̃mۂŝő̂悤łA
 *   ۂɂ́AAvP[VReLXgpceFileLoad()ڌĂ΂邱Ƃ͂܂B
 *   pceFileLoad()Ă΂菇͎̂ƂłF(runapp.cAppStart()֐Q)
 *	1. pceAppExecFile() c st@Ci[AAvP[VIv
 *	2. AppLoop()甲 c AvP[VI
 *	3. ResetHeap(INITAPPEXTBUFF) c q[v̈0x13e000`0x13ffffɐݒ
 *	4. search_app() -> pceFileLoad() c q[v̈悩(0x2000-32)oCg̃mہA
 *	                                    ̃gĎst@CWJB
 *	5. InitHeapAndSP() c q[v̈AvP[V`0x13ffffɐݒ
 *	6. AppInit(),AppLoop() c AvP[VsJn
 *   ̂悤ɁApceFileLoad()Ă΂ƂAAvP[V͊ɏIĂ܂B
 *   AvP[VIAq[v̈͋I0x13e000`0x13ffffɍĐݒ肳܂B
 *   ]āApceFileLoad()mۂ镪̃cĂKv͂܂B
 * * pceFileCreate/Rename/Delete()A4096oCg(=BLOCKSIZE)̃mۂs܂B
 *   BIOS1.18݁AAvP[VReLXgŃmۂsAPÍA3łB
 *   ƂA(mۂ郁{Ǘ̈)̋󂫃΁A蓖Đ܂B
 *   ȏAcĂȂ΂Ȃ󂫃̍ŏTCÝF
 *	BLOCKSIZE + sizeof(HEAPMEM)
 *   ƂȂ܂B
 * * BIOSXVɂāAƑ傫ȃmۂsAPIǉꂽꍇ́A
 *   HEAPMARGIN𒲐Kv܂B
 */
#define HEAPMARGIN	(BLOCKSIZE + sizeof(HEAPMEM))	/* VXepq[v̈TCY */
static void* heap;					/* malloc()pq[v̈       */

/*****************************************************************************
 *	P/ECEpE[maint[[N
 *****************************************************************************/

static int  app_init();
static void app_proc();
static void app_exit();

/* * ėpWX^̂AۑKv̂́Ar0`r3݂̂łB
 *   [S5U1C33000C_J.pdf p.84]
 */
typedef struct _CONTEXT {
	int r0, r1, r2, r3;
	int* sp;
} CONTEXT;
/* * system_contextuser_context́AstaticϐƂĂ̂łA
 *   CRpĆAasmubNŕϐ삵Ă邱Ƃ𔻒fłA
 *   "system_context`Ă邪AgĂȂ"ƌx܂B
 *   ́Ax}̂߂ɁAO[oϐƂ邱Ƃɂ܂B
 */
CONTEXT system_context;	/* VXeReLXgۑp */
CONTEXT user_context;	/* [U[ReLXgۑp */

void
pceAppInit()
{
	/* [U[ReLXg܂B */
	/* Fri Jun 21 19:22:00 JST 2002 Naoyuki Sawa
	 * - ܂ŁAVXeX^bNƃ[U[X^bÑTCY̕źA
	 *       1000`1C00:[U[X^bN(3KB)
	 *       1C00`2000:VXeX^bN(1KB)
	 *   ƂĂ܂AGSMĐ@\̒ǉɔAVXeX^bN𑝗ʂ܂B
	 * - GSMĐ[`́A[U[^VXeǂ̃X^bNg\܂B
	 *   TEh荞݂[U[ReLXgŔꍇ̓[U[X^bNB
	 *   TEh荞݂VXeReLXgŔꍇ̓VXeX^bNg܂B
	 * - GSMĐ@\gꍇAVXeX^bN1C00`2000ł͑܂łB
	 *   ƂAKv肬̃VXeX^bNTCY1B00`2000̂悤łB
	 * - 炵1B80`ɂĂ݂ƁASTART̃j[߂Ƃɗ܂B
	 *   P/ECE WatcherŊώ@ƁA1B10܂ŎgĂ܂BȂ댯łB
	 * - ŁA]T1A00`2000܂ŃVXeX^bNƂ邱Ƃɂ܂B
	 *   ŁAVXeX^bNɂ͈ꉞA256oCgx̗]T邱ƂɂȂ܂B
	 * - [U[X^bNɂ͂܂]T悤łB
	 *   AvP[Vɂ܂Aʂ񂬂̃~jQ[ŎĂ݂ƂA
	 *   1800`1A00xgĂ炸A܂2KBx̗]T悤łB
	 */
	user_context.sp = (int*)0x1A00;		/* 1000`1A00:[U[X^bN(2.5KB) */
						/* 1A00`2000:VXeX^bN(1.5KB) */
	*--user_context.sp = (int)app_exit;	/* app_init()ԂɌĂ΂֐ */
	*--user_context.sp = (int)app_init;	/* Gg[|Cg(̒mainĂ) */

	/* pceLCDDrawObjectCXg[܂B */
	hook_LCDDrawObject();
}

void
pceAppProc(int count)
{
	/* yield()ƃX^bNt[̍\킹Kv̂ŁA
	 * Ȃ̊֐oR܂B
	 */
	app_proc();
}

void
pceAppExit()
{
	/* atexit()œo^ꂽIԐ΁AĂяo܂B */
	if(exit_func != NULL) exit_func();

	/* pceLCDDrawObjectACXg[܂B */
	unhook_LCDDrawObject();
}

static int
app_init()
{
	int size;

	/* * s\̂鏉́ApceAppInit()ł͂ȂAōsĂB
	 *   pceAppInit()̒ŎsoĂAAvP[VI̎iȂłB
	 *   pceAppInit()̒pceAppReqExit()gĂʂ܂!! (BIOS1.18)
	 * * app_init()pceAppProc()̒Ȃ̂ŁApceAppReqExit()LłB
	 */

	/* malloc()pq[v̈܂B
	 * * J͍sĂ܂B
	 *   AvP[VÍAVXeɂq[vZbgɔCĂ܂B
	 */
	size = pceHeapGetMaxFreeSize();
	size -= HEAPMARGIN;
	if(size <= 0) DIE();    /* VXeq[vȂقǁA󂫃ɒ[ɏȂ */
	heap = pceHeapAlloc(size);
	if(heap == NULL) DIE(); /* HEAPMARGIN{oCg̋󂫂ȂAǗ̈悪Ȃ */
	ansi_InitMalloc((int)heap, (int)heap + size);

	/* AvP[V`̃Gg|CgցB */
	return main();
}

static void
app_proc()
{
	asm("
	; VXeReLXgޔ܂B
	xld.w %r7, system_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; [U[ReLXg𕜌܂B
	xld.w %r7, user_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

static void
app_exit()
{
	asm("
	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4

	; Iv𔭍s܂B
	ld.w %r12, %r10
	xcall pceAppReqExit
	");
}

void
yield()
{
	asm("
	; [U[ReLXgޔ܂B
	xld.w %r7, user_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; VXeReLXg𕜌܂B
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

int
atexit(void (*func )())
{
	/* ݂̎ł́Axڂ͎s܂B */
	if(exit_func != NULL) return -1;

	/* ֐|C^i[܂B */
	exit_func = func;

	return 0;
}

/*****************************************************************************
 *	ʃx֐/_~[֐
 *****************************************************************************/

/* ʃx֐F	WCuĂ΂́B
 *			AvP[V璼ڎgƂ͂܂B
 * _~[֐F		WCũwb_Ő錾Ă邪A
 *			ĂȂiCuɑ݂ȂjB
 * ]āÅ֐ clippce.h Ő錾Kv͂܂B
 */

/* exit(),abort()Ă΂܂B */
void
_exit()
{
	pceAppReqExit(0); /* Iv𔭍sāA */
	yield();          /* VXeɐԂ */
	/* Ayield()͐Ԃ܂B      */
}

/*****************************************************************************
 *	[eBeBF`
 *****************************************************************************/

void
draw_object(PIECE_BMP* src, int dx, int dy, int sx, int sy, int w, int h, int param)
{
	DRAW_OBJECT obj;

	pceLCDSetObject(&obj, src, dx, dy, sx, sy, w, h, param);
	pceLCDDrawObject(obj);
}

/****************************************************************************
 *	[eBeBFt@C
 ****************************************************************************/

int
file_read(FILEACC* fa, void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* p = (char*)ptr;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̓ǂݍ݃ItZbg܂ރZN^ԍ                         */
		sln = pceFileReadSct(fa, NULL, sct, BLOCKSIZE);	/* sln = ̃ZN^̃f[^TCY(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                   */

		/* ̃ZN^ǂݍރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ǂݍ݉\ȍőf[^TCY                 */
		if(sln > len - i) sln = len - i;		/* ǂݍ݉\ȍőf[^TCYcǂݍ݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͓ǂݍ݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^obt@֓ǂݍ݂܂B */
		memcpy(p + i, fa->aptr + sof, sln);
		i += sln;
	}

	return i;
}

int
file_write(FILEACC* fa, const void* ptr, int ofs, int len)
{
	int i, sct, sof, sln;
	char* buf;
	const char* p = (const char*)ptr;

	/* v1.18݂P/ECEJ[ĺApceFileOpen()Ɏw肳ꂽmode𖳎܂B
	 *   FOMD_RDŊJt@Cɑ΂ĂpceFileWriteSct()ł܂A
	 *   FOMD_WRŊJt@Cɑ΂ĂpceFileReadSct()ł܂B
	 *   file_write()֐ɓnt@ĆAFOMD_WRŊJĂ͂łA
	 *   L̓𗘗pāApceFileReadSct()gĂ܂Ă܂B
	 */

	/* ZN^̈ꕔ邽߂ɁAZN^ŜRAMɓǂݍރobt@mۂ܂B */
	buf = (char*)malloc(BLOCKSIZE);
	if(buf == NULL) return 0;

	i = 0;
	while(i < len) {
		/* ZN^̃tbVAhX擾܂B */
		sct = (ofs + i) / BLOCKSIZE;			/* sct = ݂̏݃ItZbg܂ރZN^ԍ                             */
		sln = pceFileReadSct(fa, buf, sct, BLOCKSIZE);	/* ̃ZN^̑Sf[^擾܂B(ŏIZN^̂sln<=BLOCKSIZEɂȂ܂) */
		if(sln == 0) break;				/* ԂItZbg                                                       */

		/* ̃ZN^ɏރTCY肵܂B */
		sof = (ofs + i) % BLOCKSIZE;			/* ZN^ItZbg                                                       */
		sln -= sof;					/* ZN^ItZbgȍ~ɏ݉\ȍőf[^TCY                   */
		if(sln > len - i) sln = len - i;		/* ݉\ȍőf[^TCYc菑݃TCYȏȂA؂l߂܂ */
		if(sln <= 0) break;				/* ԂItZbg߁A܂͏݃TCY0ȉw肳ꂽ(len<=0)    */

		/* ZN^̑Sf[^̈ꕔ܂B */
		memcpy(buf + sof, p + i, sln);
		i += sln;

		/* ZN^̑Sf[^tbVɏ߂܂B */
		pceFileWriteSct(fa, buf, sct, BLOCKSIZE);	/* ŏIZN^̖ߕ́ApceFileWriteSct()ɂĐ؂l߂܂  */
								/* Ŏs邱Ƃ͂肦Ȃ͂Ȃ̂ŁAG[`FbN͍s܂ */
	}

	/* obt@J܂B */
	free(buf);

	return i;
}

int
file_inflate(FILEACC* fa, void* outbuf, int outlen, int inofs, int inlen)
{
#define INBUFSIZ	0x400	/* ̓obt@TCY(\) */

	int retval, done = 0;
	z_stream z;
	unsigned char* inbuf;

	/* kf[^TCY0ȂAt@CI[܂łƌȂ܂B */
	if(inofs < 0 || fa->fsize - 1 < inofs) return 0; /* ItZbgs */
	if(inlen == 0) inlen = fa->fsize - inofs;
	if(inofs + inlen > fa->fsize) return 0; /* kf[^TCYs */

	/* B */
	memset(&z, 0, sizeof z);
	retval = inflateInit(&z);
	if(retval != Z_OK) return 0; /* sBsH */
	/* ȍ~̃G[́Areturn 0 ł͂Ȃ goto ERR łI */

	/* ̓obt@mۂ܂B
	 * next_inŒڃtbṼf[^wƂł܂A
	 * ܂͓삪mFł܂ŁA킩Ղ@̂邱Ƃɂ܂B
	 */
	inbuf = (unsigned char*)malloc(INBUFSIZ);
	if(inbuf == NULL) goto ERR; /* s */

	z.next_out = (unsigned char*)outbuf; /* o̓|C^     */
	z.avail_out = outlen;                /* o̓obt@c */
	for(;;) {
		if(z.avail_in == 0) {      /* ͎cʂ[ɂȂ */
			z.next_in = inbuf; /* ̓|C^ɖ߂ */
			z.avail_in = file_read(fa, inbuf, inofs, inlen < INBUFSIZ ? inlen : INBUFSIZ); /* f[^ǂ */
			if(z.avail_in == 0) goto ERR; /* ̓f[^sBĂH */
			inofs += z.avail_in;
			inlen -= z.avail_in;
		}
		retval = inflate(&z, Z_NO_FLUSH); /* WJ */
		if(retval == Z_STREAM_END) { done = 1; break; } /*  */
		if(retval != Z_OK) goto ERR; /* ̓f[^sBĂH */
		if(z.avail_out == 0) goto ERR; /* o̓obt@s */
	}

	/* FALL THRU */
ERR:
	/* nB */
	retval = inflateEnd(&z);
	if(retval != Z_OK) done = 0; /* ǂŃ󂵂H */

	/* ̓obt@J܂B
	 * malloc()ɎsĂꍇinbuf=NULLłAfree(NULL)͈SłB
	 */
	free(inbuf);

	/* ȂWJ̃TCYAsȂ0Ԃ܂B */
	return done ? outlen - z.avail_out : 0;

#undef INBUFSIZ
}

FILE_INFO*
fpak_find(FILEACC* fa, const char* fname)
{
	int retval, i, ofs;
	FILE_PAC_INFO fpi;
	static FILE_INFO fi; /* ߂l͂wĂ܂ */

	/* t@CpbNǂ݂܂B */
	retval = file_read(fa, &fpi, 0, sizeof fpi);
	if(retval != sizeof fpi) return NULL; /* Ă */
	if(fpi.head != FILE_PAC_INFO_HEAD)return NULL; /* VOl`s */
	if(fpi.famount < 0) return NULL; /* t@Cs */

	/* t@Cǂ݂܂B */
	ofs = sizeof fpi;
	for(i = 0; i < fpi.famount; i++) {
		retval = file_read(fa, &fi, ofs, sizeof fi);
		if(retval != sizeof fi) return NULL; /* Ă */
		if(strncmp(fi.fname, fname, sizeof fi.fname) == 0) return &fi; /*  */
	}

	return NULL; /* Ȃ */
}

int
fpak_inflate(FILEACC* fa, void* outbuf, int outlen, const char* fname)
{
	FILE_INFO* fi;

	/* t@CT܂B */
	fi = fpak_find(fa, fname);
	if(fi == NULL) return 0; /* Ȃ */

	/* t@CWJ܂B */
	return file_inflate(fa, outbuf, outlen, fi->offset, fi->size);
}

/****************************************************************************
 *	[eBeBFGSM
 ****************************************************************************/

#define TRAP_HSDMA1	23	/* DMA Ch.1]I荞݃xN^ԍ   */
#define MAXCH		4	/* `lFP/ECEdl                    */
#define BLKN		2	/* ubNFA2ȏBԂ2ŏ[ */
#define BLKS		320	/* ubNTCY(Tv)FA64xN */
#define GSMS		160	/* GSMt[TCY(Tv)FGSMdl   */

typedef struct _STREAM {
	PCEKSENT old_isr;	/* +0,4:̃TEh荞݃[`       */
	volatile char busy;	/* +4,1:stream_fill()ē֎~tO        */
	volatile char bc;	/* +5,1:󂫃ubN                     */
	         char bi;	/* +6,1:󂫃ubN̐擪CfNX       */
	volatile char loop;	/* +7,1:c胋[v(݂̃[v܂) */
	/* t@C֘A */
	FILEACC fa;		/* GSMt@C               */
	int ofs;		/* GSMt@C̓ǂݍ݈ʒu */
	/* GSM֘A */
	gsm g;			/* GSMRo[^               */
	gsm_frame gf;		/* GSMt[ǂݍ݃obt@ */
	gsm_signal gs[GSMS];	/* GSMt[WJobt@     */
	int rest;		/* GSMt[̎cTv */
	/* Wave֘A */
	int ch;			/* Đ`l */
	PCEWAVEINFO wi[BLKN];	/* WAVEwb_   */
	short wb[BLKN][BLKS];	/* WAVEf[^   */
} STREAM;
static STREAM stream;

static void stream_isr();
static void stream_fill();
static void stream_fill_busy();
static void stream_endproc(PCEWAVEINFO* wi);

int
stream_play(int ch, const char* fname, int loop)
{
	STREAM* ps = &stream;

	int retval, i;
	PCEWAVEINFO* wi;

	/* mɒ~܂B */
	stream_stop();

	/* ŜNA܂B */
	memset(ps, 0, sizeof(STREAM));

	/* t@CJ܂B */
	retval = pceFileOpen(&ps->fa, fname, FOMD_RD);
	if(retval != 0) {
		return -1;
	}

	/* GSMRo[^쐬܂B */
	ps->g = gsm_create();
	if(ps->g == NULL) {
		pceFileClose(&ps->fa);
		return -1;
	}

	/* Đ`li[܂B */
	if(ch < 0 || MAXCH - 1 < ch) {
		gsm_destroy(ps->g);
		pceFileClose(&ps->fa);
		return -1;
	}
	ps->ch = ch;

	/* [v񐔂i[܂B */
	ps->loop = loop;

	/* WAVE܂B */
	for(i = 0, wi = ps->wi; i < BLKN; i++, wi++) {
		wi->type = PW_TYPE_16BITPCM; /* ւɂ̂PW_TYPE_CONTsv */
		wi->pData = &ps->wb[i][0];
		wi->len = BLKS;
		wi->next = &ps->wi[(i + 1) % BLKN]; /* ւɂ܂ */
		wi->pfEndProc = stream_endproc;
	}

	/* ĐJnOɁASubNɃf[^𖞂Ă܂B */
	ps->bc = BLKN;
	stream_fill();
	stream_fill_busy(); /* RpČx} */

	/* TEh荞݃[`tbNAWaveĐJn܂B
	 * ̓̊ԂɃTEh荞݂Ă͂܂B
	 */
DISABLE;
	ps->old_isr = pceVectorSetTrap(TRAP_HSDMA1, stream_isr);
	pceWaveDataOut(ps->ch, &ps->wi[0]);
ENABLE;

	return 0;
}

void
stream_stop()
{
	STREAM* ps = &stream;

	/* ĐłȂΉ܂B */
	if(ps->old_isr == NULL) return;

	/* WAVEĐ~ATEh荞݃[`ɖ߂܂B
	 * ̓̊ԂɃTEh荞݂Ă͂܂B
	 */
DISABLE;
	pceWaveAbort(ps->ch);
	pceVectorSetTrap(TRAP_HSDMA1, ps->old_isr);
	ps->old_isr = NULL;
ENABLE;

	/* GSMRo[^폜܂B */
	gsm_destroy(ps->g);

	/* t@C܂B */
	pceFileClose(&ps->fa);
}

static void
stream_isr()
{
	/* [%sp+ 0]:psr
	 * [%sp+ 1]:pc
	 */
	asm("
	pushn %r15
	ld.w %r0, %alr
	ld.w %r1, %ahr
	pushn %r1
	");
	/* [%sp+ 0]:alr
	 * [%sp+ 1]:ahr
	 * [%sp+ 2]:r0
	 * [%sp+ 3]:r1
	 * [%sp+ 4]:r2
	 * [%sp+ 5]:r3
	 * [%sp+ 6]:r4
	 * [%sp+ 7]:r5
	 * [%sp+ 8]:r6
	 * [%sp+ 9]:r7
	 * [%sp+10]:r8
	 * [%sp+11]:r9
	 * [%sp+12]:r10
	 * [%sp+13]:r11
	 * [%sp+14]:r12
	 * [%sp+15]:r13
	 * [%sp+16]:r14
	 * [%sp+17]:r15
	 * [%sp+18]:psr
	 * [%sp+19]:pc
	 */
	asm("
	 ld.w %r0, [%sp+18]		; psr
	xld.w %r3, stream
	 ld.w %r4, [%r3]+		; old_isr
	xld.w %r1, stream_fill_busy
	xld.w %r2, stream_isr_ret_busy
	btst [%r3], 0			; busy?
	jrne stream_isr_busy
	xld.w %r1, stream_fill
	xld.w %r2, stream_isr_ret
	bset [%r3], 0			; busy <- 1
stream_isr_busy:
	pushn %r2
	");
	/* %r3     :&busy
	 * %r4     :old_isr
	 * [%sp+ 0]:psr
	 * [%sp+ 1]:stream_fill/busy
	 * [%sp+ 2]:stream_isr_ret/busy
	 * [%sp+ 3]:alr
	 * [%sp+ 4]:ahr
	 * [%sp+ 5]:r0
	 * [%sp+ 6]:r1
	 * [%sp+ 7]:r2
	 * [%sp+ 8]:r3
	 * [%sp+ 9]:r4
	 * [%sp+10]:r5
	 * [%sp+11]:r6
	 * [%sp+12]:r7
	 * [%sp+13]:r8
	 * [%sp+14]:r9
	 * [%sp+15]:r10
	 * [%sp+16]:r11
	 * [%sp+17]:r12
	 * [%sp+18]:r13
	 * [%sp+19]:r14
	 * [%sp+20]:r15
	 * [%sp+21]:psr
	 * [%sp+22]:pc
	 */
	asm("
	jp %r4				; * old_isr->(iret)->stream_fill/busy->(ret)->stream_isr_ret/busy
					;   Ԃ̊荞݋֎~h߁Aold_isrretiƂ
					;   荞ݔpsr(ĂIE=1)𕜌Ă܂B
					; * 荞݃[`ł̓tOۑKv̂ŁA
					;   stream_isrAƂretł͂ȂretigȂ΂܂B
					;   ܂A荞ݔpsrA񕜌Ă܂B
stream_isr_ret:
	bclr [%r3], 0			; S1C33̊֐KɂAr3͕ێĂ͂B
stream_isr_ret_busy:
	");
	/* [%sp+ 0]:alr
	 * [%sp+ 1]:ahr
	 * [%sp+ 2]:r0
	 * [%sp+ 3]:r1
	 * [%sp+ 4]:r2
	 * [%sp+ 5]:r3
	 * [%sp+ 6]:r4
	 * [%sp+ 7]:r5
	 * [%sp+ 8]:r6
	 * [%sp+ 9]:r7
	 * [%sp+10]:r8
	 * [%sp+11]:r9
	 * [%sp+12]:r10
	 * [%sp+13]:r11
	 * [%sp+14]:r12
	 * [%sp+15]:r13
	 * [%sp+16]:r14
	 * [%sp+17]:r15
	 * [%sp+18]:psr
	 * [%sp+19]:pc
	 */
	asm("
	popn %r1
	ld.w %ahr, %r1
	ld.w %alr, %r0
	popn %r15
	");
	/* [%sp+ 0]:psr
	 * [%sp+ 1]:pc
	 */
	asm("
	reti
	");
}

static void
stream_fill()
{
	STREAM* ps = &stream;

	int retval, n, c;
	short s, *dst, *src;

	while(ps->bc != 0) {
		/* 󂫃ubN̐擪AhXƁAWJGSMTv܂B
		 * * 8KHzGSMf[^A16KHzWAVEf[^ɕϊȂWĴŁA
		 *   WJGSMTv́AubÑTv̔ƂȂ܂B
		 */
		n = BLKS / 2;
		dst = &ps->wb[(int)ps->bi][0];

		/* [vȂ... */
		if(ps->loop != 0) {
			/* WAVEf[^쐬܂B */
			do {
				if(ps->rest == 0) {
					/* GSMt[ǂݍ݂܂B */
					retval = file_read(&ps->fa, ps->gf, ps->ofs, sizeof(gsm_frame));

					/* ̓ǂݍ݈ʒui߂܂B */
					ps->ofs += retval;

					/* GSMt[ǂݍ߂... */
					if(retval == sizeof(gsm_frame)) {
						/* GSMt[WJ܂B */
						retval = gsm_decode(ps->g, ps->gf, ps->gs);
						if(retval != 0) {
							/* WJɎsAɂ܂B(ĂH) */
							memset(ps->gs, 0, sizeof(gsm_signal) * GSMS);
						}
					/* t@CI[Ȃ... */
					} else if(retval == 0) {
						/* loop < 0 ... [vȂ̂ŁA߂B
						 * loop = 0 ... ɒ~Ă̂ŁAɂB
						 * loop = 1 ... loop0(=~)ɂāAɂB
						 * loop > 1 ... loop1炵āA߂B
						 */
						if(ps->loop < 0 || (ps->loop != 0 && --ps->loop != 0)) {
							ps->ofs = 0;
							continue;
						} else {
							memset(ps->gs, 0, sizeof(gsm_signal) * GSMS);
						}
					/* GSMt[r[ɓǂݍ߂... */
					} else {
						/* ɂ܂B(ĂH) */
						memset(ps->gs, 0, sizeof(gsm_signal) * GSMS);
					}

					/* WJf[^̑STvLłB */
					ps->rest = GSMS;
				}

				/* GSMt[WJobt@(8KHz)WAVEf[^(16KHz)փRs[܂B */
				src = &ps->gs[GSMS - ps->rest];
				if(n <= ps->rest) {
					c = n;
					n = 0;
					ps->rest -= c;
				} else {
					c = ps->rest;
					n -= c;
					ps->rest = 0;
				}
				do {
					s = *src++;
					*dst++ = s;
					*dst++ = s;
				} while(--c != 0);
			} while(n != 0);

		/* Ƀ[vIĂ... */
		} else {
			/* ɂ܂B */
			do {
				*dst++ = 0;
				*dst++ = 0;
			} while(--n != 0);
		}

		/* 󂫃ubN̐擪CfNXi߂܂B */
		if(++ps->bi == BLKN) ps->bi = 0;

		/* 󂫃ubN炵܂B
		 * * stream_fill()stream_endproc()Ɋ荞܂\̂ŁA
		 *   u󂫃ubN擾1炷i[v̏̑OŊ荞ݐ䂪KvłB
		 * * stream_isr()oRł̊֐Ă΂ꂽ́A荞݋Ԃ͕sȂ̂ŁA
		 *   PDISABLE/ENABLEł͂ȂAԑޔE֎~EsKv܂B
		 * * 悭lAstream_isr()oRŌĂ΂ꂽ́A荞݋Ɍ܂Ă悤ȋCĂ܂B
		 *   stream_isr()͍DMÅ荞݃nhȂ̂łA
		 *   stream_isr()Ă΂ꂽDMÅ荞݂ꂽ荞݂ĂB
		 * * Ƃ킯ŁAPDISABLE/ENABLEłvm܂B
		 *   ܂AԑޔE֎~EmAȂƂQ͂Ȃ̂ŁÂ܂܂ɂĂ܂B
		 */
		asm("
		pushn %r2
		ld.w %r0, %psr			; %psrۑ
		xand %r1, %r0, 0xffffffef	; 荞݋֎~
		ld.w %psr, %r1
		xld.w %r1, stream + 5		; stream.bc--
		ld.b %r2, [%r1]
		sub %r2, 1
		ld.b [%r1], %r2
		ld.w %psr, %r0			; %psr
		popn %r2
		");
	}
}

static void
stream_fill_busy()
{
	/* ܂B */
}

static void
stream_endproc(PCEWAVEINFO* wi)
{
	STREAM* ps = &stream;

	/* 󂫃ubN𑝂₵܂B
	 * * PCEWAVEINFO.pfEndProc͊荞݋ԂŌĂ΂܂A
	 *   TEhhCoɂčē֎~Ă̂ŁA
	 *   ups->bc++v̑Oł̊荞ݐ͕Kv܂B
	 * * ē֎~́Asound_isr3()̌㔼ōsĂ܂B
	 *   isnd.c 421`430sQƁABIOS 1.18݁j
	 */
	ps->bc++;
}
